#include <stdio.h>
//#include <vga.h>
class pal{
    public:
      unsigned char r[256], g[256], b[256];
      void setpal();
      void savepal(char *ime);
      void loadpal(char *ime);
      void clr(); 
};
class bmp{
    public:
       pal barva;
       unsigned char *bmpbuf;
       char tom;
       int trans;
       unsigned int bmp_x, bmp_y;
       void loadbmp(char *ime,char tele);
       void setpal();
       void savepal(char *ime);
       void putbmp(int x1, int y1);
       void freebmp();
};
long filesize(FILE *fp);
void pal::setpal()
{ int i;
  for(i=0;i<256;i++){vga_setpalette(i,r[i]/4,g[i]/4,b[i]/4);}
}
void pal::savepal(char *ime)
{ FILE *fp;
  int i;
  fp=fopen(ime,"wb");
  for(i=0;i<256;i++){
    fwrite(&r[i],1,1,fp);
    fwrite(&g[i],1,1,fp);
    fwrite(&g[i],1,1,fp);
  }
  fclose(fp); 
}
void pal::loadpal(char *ime)
{ FILE *fp;
  int i;
  fp=fopen(ime,"rb");
  for(i=0;i<256;i++){
    fread(&r[i],1,1,fp);
    fread(&g[i],1,1,fp);
    fread(&b[i],1,1,fp);
  }
  fclose(fp);
}
void pal::clr()
{ int i;
  for(i=0;i<256;i++){r[i]=0;g[i]=0;b[i]=0;}
}
void bmp::loadbmp(char *ime,char tele)
{ FILE *fp;
  unsigned char x1,y1,n,ch;
  unsigned int bmp_ofs, bmp_col;
  unsigned long int sizer;
  int i,a,b,cols;
  tom=tele;
  trans=0;
  barva.clr();
  fp=fopen(ime,"rb");
  fseek(fp,10,SEEK_SET);fread(&x1,1,1,fp);bmp_ofs=x1;
                        fread(&x1,1,1,fp);bmp_ofs+=x1*0x100;
  fseek(fp,46,SEEK_SET);fread(&x1,1,1,fp);bmp_col=x1;
                        fread(&x1,1,1,fp);bmp_col+=x1*0x100;
  fseek(fp,18,SEEK_SET);fread(&x1,1,1,fp);bmp_x=x1;
                        fread(&x1,1,1,fp);bmp_x+=x1*0x100;
  fseek(fp,22,SEEK_SET);fread(&y1,1,1,fp);bmp_y=y1;
                        fread(&y1,1,1,fp);bmp_y+=y1*0x100;
  fseek(fp,54,SEEK_SET);
  for(i=0;i<bmp_col;i++){
    fread(&barva.b[i],1,1,fp);//barva.b[i]=barva.b[i]/4;
    fread(&barva.g[i],1,1,fp);//barva.g[i]=barva.g[i]/4;
    fread(&barva.r[i],1,1,fp);//barva.r[i]=barva.r[i]/4;
    fread(&n,1,1,fp);
  }
  sizer=filesize(fp)-bmp_ofs;
  bmpbuf=new unsigned char[sizer];
  fseek(fp,bmp_ofs,SEEK_SET);
  fread(bmpbuf,sizer,1,fp);
  fclose(fp);
}
void bmp::setpal()
{
  barva.setpal();
}
void bmp::savepal(char *ime)
{
  barva.savepal(ime);
}
void bmp::putbmp(int x1, int y1)
{ unsigned char col;
  int a,b;
  unsigned long int cnt=0;
  for(a=0;a<bmp_y;a++){
    for(b=0;b<bmp_x;b++){
      col=bmpbuf[cnt];cnt++;
      if(col!=trans){vga_setcolor(col);vga_drawpixel(x1+b,y1+bmp_y-a-1);}
    }
    cnt+=tom;
  }
}
void bmp::freebmp()
{
  delete[] bmpbuf;
}
long filesize(FILE *fp)
{
  long curpos, length;
  curpos=ftell(fp);
  fseek(fp,0L,SEEK_END);
  length=ftell(fp);
  fseek(fp,curpos,SEEK_SET);
  return (length);
}
//---------------------------- <eof> -------------------------------------------