      char MIS_HOTSPOTX, MIS_HOTSPOTY; 
      unsigned char MIS_CURSOR[20][20];
      unsigned char MIS_CURSOROLD[20][20];
      unsigned char MIS_COL[256];
      char MIS_PRESSED;
      char MIS_TRANSPARENT;
      int MIS_X, MIS_Y, MIS_XO, MIS_YO;
      char MIS_LEFTBUTTON, MIS_RIGHTBUTTON;
      char MIS_ONSCREEN, MIS_BUTTON;

void mis_putmouse(int x, int y);
void mis_getpod(int x, int y);
void mis_putpod(int x, int y);
void mis_init(int num);
void mis_onn();
void mis_off();
void mis_move();
void mis_close();
void mis_puscica();
void mis_load(char *fname);

      
void mis_putmouse(int x, int y)
{ int getmax_x, getmax_y, x1, y1;
  MIS_ONSCREEN=1;
  getmax_x=vga_getxdim();getmax_y=vga_getydim();
  for(x1=0;x1<20;x1++)
    for(y1=0;y1<20;y1++)
    {
      if(((x1+x-MIS_HOTSPOTX<getmax_x)&&(y1+y-MIS_HOTSPOTY<getmax_y))&&
      ((x1+x-MIS_HOTSPOTX>0)&&(y1+y-MIS_HOTSPOTY>0)))
      { 
        if(MIS_CURSOR[x1][y1]!=MIS_TRANSPARENT)
        {
          vga_setcolor(MIS_COL[MIS_CURSOR[x1][y1]]);vga_drawpixel(x1+x-MIS_HOTSPOTX,y1+y-MIS_HOTSPOTY);	
	}
      }
    }
}
void mis_getpod(int x, int y)
{ int getmax_x, getmax_y, x1, y1;
  getmax_x=vga_getxdim();getmax_y=vga_getydim();
  for(x1=0;x1<20;x1++)
    for(y1=0;y1<20;y1++)
    {
      if(((x1+x-MIS_HOTSPOTX<getmax_x)&&(y1+y-MIS_HOTSPOTY<getmax_y))&&
      ((x1+x-MIS_HOTSPOTX>0)&&(y1+y-MIS_HOTSPOTY>0)))
      {
        if(MIS_CURSOR[x1][y1]!=MIS_TRANSPARENT)
	{
	  MIS_CURSOROLD[x1][y1]=vga_getpixel(x1+x-MIS_HOTSPOTX,y1+y-MIS_HOTSPOTY);
	}
      }
    }
}
void mis_putpod(int x, int y)
{ int getmax_x, getmax_y, x1, y1;
  MIS_ONSCREEN=0;
  getmax_x=vga_getxdim();getmax_y=vga_getydim();
  for(x1=0;x1<20;x1++)
    for(y1=0;y1<20;y1++)
    {
      if(((x1+x-MIS_HOTSPOTX<getmax_x)&&(y1+y-MIS_HOTSPOTY<getmax_y))&&
      ((x1+x-MIS_HOTSPOTX>0)&&(y1+y-MIS_HOTSPOTY>0)))
      {
        if(MIS_CURSOR[x1][y1]!=MIS_TRANSPARENT)
	{
	  vga_setcolor(MIS_CURSOROLD[x1][y1]);vga_drawpixel(x1+x-MIS_HOTSPOTX,y1+y-MIS_HOTSPOTY);
	}
      }
    }

}
void mis_init(int num)
{ int x;
  vga_setmousesupport(num);
  mouse_init("/dev/mouse", MOUSE_MICROSOFT, MOUSE_DEFAULTSAMPLERATE);
  mouse_setxrange(0, vga_getxdim()-1);
  mouse_setyrange(0, vga_getydim()-1);
  mouse_setwrap(MOUSE_NOWRAP);
  mouse_setscale(16);
  mouse_setposition(vga_getxdim()/2,vga_getydim()/2);
  MIS_ONSCREEN=0;
  MIS_TRANSPARENT=0;
  for(x=0;x<256;x++)MIS_COL[x]=x;
}
void mis_onn()
{
  if(MIS_ONSCREEN==0){
    mouse_update();
    MIS_X=mouse_getx();MIS_XO=MIS_X;
    MIS_Y=mouse_gety();MIS_YO=MIS_Y;
    mis_getpod(MIS_X,MIS_Y);
    mis_putmouse(MIS_X,MIS_Y);
    MIS_ONSCREEN=1;
  }
}
void mis_off()
{
  if(MIS_ONSCREEN==1){
    mis_putpod(MIS_XO,MIS_YO);MIS_ONSCREEN=0;
  }
}
void mis_move()
{
  mouse_update();
  if(MIS_ONSCREEN==1){
    //mouse_update();
    MIS_X=mouse_getx();
    MIS_Y=mouse_gety();
    MIS_BUTTON=mouse_getbutton();
    if(MIS_BUTTON & MOUSE_LEFTBUTTON){MIS_LEFTBUTTON=1;}else{MIS_LEFTBUTTON=0;}
    if(MIS_BUTTON & MOUSE_RIGHTBUTTON){MIS_RIGHTBUTTON=1;}else{MIS_RIGHTBUTTON=0;}
    if((MIS_X!=MIS_XO)||(MIS_Y!=MIS_YO))
    {
      mis_putpod(MIS_XO,MIS_YO);
      mis_getpod(MIS_X,MIS_Y);
      mis_putmouse(MIS_X,MIS_Y);
      MIS_XO=MIS_X;MIS_YO=MIS_Y;
    }
  }
}
void mis_close()
{
  mouse_close();
}
void mis_puscica()
{ char x,y;
  MIS_HOTSPOTX=0;MIS_HOTSPOTY=0;
  for(x=0;x<20;x++)
    for(y=0;y<20;y++){MIS_CURSOR[x][y]=0;}
  MIS_CURSOR[0][0]=1;
  MIS_CURSOR[0][1]=1;MIS_CURSOR[1][1]=1;
  MIS_CURSOR[0][2]=1;MIS_CURSOR[1][2]=2;MIS_CURSOR[2][2]=1;
  MIS_CURSOR[0][3]=1;MIS_CURSOR[1][3]=2;MIS_CURSOR[2][3]=2;MIS_CURSOR[3][3]=1;
  MIS_CURSOR[0][4]=1;MIS_CURSOR[1][4]=2;MIS_CURSOR[2][4]=2;MIS_CURSOR[3][4]=2;MIS_CURSOR[4][4]=1;
}
void mis_load(char *fname)
{ FILE *fp;
  fp=fopen(fname, "rb");
  fread(&MIS_CURSOR[0][0],20*20,1,fp);
  fclose(fp);
}